const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const family_members = sequelize.define(
    'family_members',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

member_role: {
        type: DataTypes.ENUM,
      
      

        values: [

"owner",


"adult",


"dependent",


"caregiver"

        ],

      },

has_own_account: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

display_name: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  family_members.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.family_members.belongsTo(db.family_groups, {
      as: 'family_group',
      foreignKey: {
        name: 'family_groupId',
      },
      constraints: false,
    });

    db.family_members.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });



    db.family_members.hasMany(db.file, {
      as: 'avatar',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.family_members.getTableName(),
        belongsToColumn: 'avatar',
      },
    });


    db.family_members.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.family_members.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return family_members;
};


